diff -Nur changelog-221/shortlog changelog/shortlog
--- changelog-221/shortlog	2004-01-26 23:57:47.000000000 -0500
+++ changelog/shortlog	2004-01-26 23:50:32.000000000 -0500
@@ -2078,7 +616,7 @@
 my @opts = ("help|?|h", "man", "mode=s", "compress!", "count!", "width:i",
 	    "swap!", "merge!", "warn!", "multi!", "abbreviate-names!",
 	    "by-surname!", "selftest", "ignoremerge!", "omitaddresses!",
-	    "obfuscate!");
+	    "obfuscate!", "hashfile=s", "regexpfile=s");
 #	    "bitkeeper|bk!");
 
 # How do we parse them?
@@ -2086,11 +624,28 @@
   Getopt::Long::Configure("gnu_getopt");
 }
 
+my $mypath = $ENV{_};
+
+# Find the last occurence of / (ASCII 0x2f) and set $mypath equal to the substr before it
+my $pathindex = length($mypath) - 1;
+while ($pathindex > 0) {
+	if ((ord substr($mypath, $pathindex, 1)) == 0x2f) {
+		$mypath = substr($mypath, 0, $pathindex);
+		$pathindex = 0;
+	}
+	$pathindex--;
+}
+if ($pathindex != -1) {
+	die "Error extracting base directory\n";
+}
+
 # set default options
 $opt{mode} = 'grouped';
 $opt{warn} = 1;
 $opt{omitaddresses} = 1;
 $opt{obfuscate} = 1;
+$opt{hashfile} = "$mypath/lk-hash";
+$opt{regexpfile} = "$mypath/lk-regexp";
 
 # set up proper environment
 $ENV{PATH} = '/bin:/usr/bin:/usr/local/bin';
@@ -2155,6 +710,24 @@
   $opt{width} = $ENV{COLUMNS} ? $ENV{COLUMNS} : 80;
 }
 
+# Load all regexp email address patterns
+open(REGEXPFILE, " < $opt{regexpfile}") or die "Error reading $opt{regexpfile}: $!\n";
+while(<REGEXPFILE>) {
+	if (/([^\t]+)\t([^\n]+)/) {	# Extract regexp string ($1) and name ($2)
+		push @addrregexps, ([$1 => $2]);
+	}
+}
+close REGEXPFILE;
+
+# Load all email addresses to the hash
+open(HASHFILE, " < $opt{hashfile}") or die "Error reading $opt{hashfile}: $!\n";
+while(<HASHFILE>) {
+	if (/([^\t]+)\t([^\n]+)/) {	# Extract email ($1) and name ($2)
+		$addresses{$1} = $2;
+	}
+}
+close HASHFILE;
+
 # Print the passed-in array linewise, checking for write errors
 # Then call the configured function to print %log formatted
 sub doprint(\%@ ) {
@@ -2233,13 +806,13 @@
 __END__
 =head1 NAME
 
-lk-changelog.pl - Reformat BitKeeper ChangeLog for Linux Kernel
+changelog.pl - Reformat BitKeeper ChangeLog
 
 =head1 SYNOPSIS
 
-lk-changelog.pl [options] [file [...]]
+changelog.pl [options] [file [...]]
 
-Try lk-changelog.pl --help or lk-changelog.pl --man for more information.
+Try changelog.pl --help or changelog.pl --man for more information.
 
 =head1 OPTIONS
 
@@ -2267,6 +840,12 @@
      --width[=WIDTH] specify the line length, if omitted: $COLUMNS or 80.
                      text lines will not exceed this length.
 
+     --hashfile=HASHFILE
+                     specify file with email to name data. Default: lk-hash
+     --regexpfile=REGEXPFILE
+                     specify file with email regural expression to name data.
+                     Default: lk-regexp
+
      --selftest      perform some self tests (for developers of this script)
 
 Warning: Neither --compress nor --count are currently functional with
@@ -2274,7 +853,7 @@
 
 =head1 DESCRIPTION
 
-Summarizes or reformats BitKeeper ChangeLogs for Linux Kernel 2.X.
+Summarizes or reformats BitKeeper ChangeLogs
 
 --mode options are:
 
@@ -2327,18 +906,18 @@
   their author (that is the default mode, but we specify it anyways),
   with 76 character wide lines:
 
- lk-changelog.pl --mode=grouped --width=76 ChangeLog-2.5.17
+ changelog.pl --mode=grouped --width=76 ChangeLog-2.5.17
 
 =item Reformat ChangeLog-2.5.18, displaying all changes and their
-      author on in "-ac changelog style", with 80 character wide lines:
+      author on in "Alan Cox changelog style", with 80 character wide lines:
 
- lk-changelog.pl --mode=terse --width=80 ChangeLog-2.5.18
+ changelog.pl --mode=terse --width=80 ChangeLog-2.5.18
 
 =item Reformat 2.4.19-pre ChangeLogs (several in one file) from your mailer:
 
 Use the pipe command to pipe the mail into:
 
- lk-changelog.pl --multi --mode=terse --width=80
+ changelog.pl --multi --mode=terse --width=80
 
 =back
 
@@ -2362,7 +941,7 @@
 
 Albert D. Cahalan <acahalan@cs.uml.edu>, Robinson Maureira Castillo
 <rmaureira@alumno.inacap.cl>, Greg Kroah-Hartman <greg@kroah.com>, Zack
-Brown <zbrown@tumblerings.org>.
+Brown <zbrown@tumblerings.org>, Josef "Jeff" Sipek <jeffpc@optonline.net>.
 
 =back
 
@@ -2378,7 +957,7 @@
 
 =item * --compress does not currently work with --mode=full.
 
-=item * does not detect if the changelog is already summarized (as in Marcelo's 2.4.19-pre9 announcement on the list)
+=item * does not detect if the changelog is already summarized (as in Marcelo Tosatti's 2.4.19-pre9 Linux kernel announcement)
 
 =back
 
